#import "Game.h"
#import "Ball.h"
#import "Vector2.h"
#import "math.h"

@implementation Game

- (id)initWithWidth:(float)width height:(float)height
{
    if (self = [super initWithWidth:width height:height])
    {
		
		
		
		furthestBack = [[SPPoint alloc] initWithX:(float)stationaryX y:(float)stationaryY];
	
		vanishingPoint = [[SPPoint alloc] initWithX:100 y:90];
		
		
		SPImage *fieldImage = [ SPImage imageWithContentsOfFile:@"field2.png"];
		
		field = (Ball*)[Ball sprite];
		[field addChild:fieldImage];
		[self addChild:field];
		
		SPImage *dogImage = [SPImage imageWithContentsOfFile:@"dogSitting.png"];
		
		dog = (Ball*)[Ball sprite];
		[dog addChild:dogImage];
		[self addChild:dog];
		
		SPImage *shadowImage = [SPImage imageWithContentsOfFile:@"shadow.png"];
		
		shadow = (Ball*)[Ball sprite];
		[shadow addChild:shadowImage];
		[self addChild:shadow];
        
		SPImage *ballImage = [SPImage imageWithContentsOfFile:@"ball2.png"];
		
		ball = (Ball*)[Ball sprite];
		
		[ball addChild:ballImage];
		
		[ball addEventListener:@selector(onTouchEvent:) atObject:self forType:SP_EVENT_TYPE_TOUCH];
		[ball addEventListener:@selector(onEnterFrame:) atObject:self forType:SP_EVENT_TYPE_ENTER_FRAME];
		
		touchingBall = NO;
		[self addChild:ball];
		
		
		
		[self reinitializeVars];
		
		
    }
    return self;
}

- (void)reinitializeVars
{
	flag = true;
	isThrown = false;
	chasingBall = false;
	timer = 0;
	distance = 0;
	previousTouchCount = 0;
	stationaryX = 200;
	stationaryY = 350;
	yStart = 0;
	dY = 0;
	released = 0; //reset to 0 after dog gets ball
	airTime = 0;
	timeModifier = 1;
	Magnitude = 100;
	bounceCount = 0;
	chaseStart = 0.0;
	chaseEnd = 0.0;
	ball.scaleX = 1.0;
	ball.scaleY = 1.0;
	shadow.scaleX = 1.0;
	shadow.scaleY = 1.0;
	dog.scaleX = .75;
	dog.scaleY = .75;
	dogYStart = 300;
	dogXStart = -20;
	dog.x = dogXStart;
	dog.y = dogYStart;
	dogReturn = false;
	shadow.visible = true;
}

- (void)onEnterFrame:(SPEnterFrameEvent *)event
{
	
	
	timer += .05;
	airTime = timer - released;
	timeModifier = 1.0 / (velocity / 1000.0);
	
	
	if(isThrown == false && touchingBall == NO && chasingBall == false)
	{
		furthestBack.x = stationaryX;
		furthestBack.y = stationaryY;
		
		ball.x = stationaryX;
		ball.y = stationaryY;
		
		shadow.x = ball.x;
		shadow.y = 400;
		
	}
	else if(isThrown == true && touchingBall == NO && chasingBall == false)
	{
		
		
		if(bounceCount <= 5)
		{
			
			//ball.x = stationaryX;
			//ball.y = stationaryY - ((initiald * tan(.785)) + ((-9.81 * pow(initiald, 2))/(2.0 * pow((velocity * .707), 2))));
			//NSLog(@"ball yStart: %f", yStart);
			ball.y = (yStart - ((((airTime * airTime) / timeModifier) * dY - 11.0) / (((airTime * airTime) / timeModifier) + 9.0))) - ((float)fabs(sin(airTime / timeModifier)) * Magnitude); // t^2 / X ... change X!!!
			//ball.x = xStart + 1.0 / ((airTime / timeModifier * airTime / timeModifier - 11.0) / (airTime / timeModifier * airTime / timeModifier + 9.0) + 1.3) / 8.0;
			ball.x = (xStart - ((((airTime * airTime) / timeModifier) * dX - 11.0) / (((airTime * airTime) / timeModifier) + 9.0))) + (ballWidthStart-ball.width)/2;
			//NSLog(@"%f", airTime);
			ball.scaleY = 1.0 / ((airTime / timeModifier * airTime / timeModifier - 11.0) / (airTime / timeModifier * airTime / timeModifier + 9.0) + 1.3) / 8.0;
			ball.scaleX = ball.scaleY;
			
			
			
			shadow.y = (yStart - ((((airTime * airTime) / timeModifier) * dY - 11.0) / (((airTime * airTime) / timeModifier) + 9.0)));// - ((float)fabs(sin(airTime / timeModifier)) * Magnitude); // t^2 / X ... change X!!!
			shadow.x = (xStart - ((((airTime * airTime) / timeModifier) * dX - 11.0) / (((airTime * airTime) / timeModifier) + 9.0))) + (ballWidthStart-ball.width)/2;
			shadow.scaleY = 1.0 / ((airTime / timeModifier * airTime / timeModifier - 11.0) / (airTime / timeModifier * airTime / timeModifier + 9.0) + 1.3) / 8.0;
			shadow.scaleX = ball.scaleY;
			
		
			if((float)(airTime / timeModifier) >= bounceCount * PI)
			{
				
				Magnitude *= 0.5;
				bounceCount++;
			}
		}
		else
		{
			
			
			chasingBall = true;
		}
	}
	else if(isThrown == true && touchingBall == NO && chasingBall == true)
	{
		
		
		float chaseS = 1.0 / 1.0;
		
		
		
		
		if(dog.y <= ball.y - 10 )
		{
			dogReturn = true;
		}
		
		
		if(dogReturn == false)
		{
			ddY = (dogYStart + dog.height/2) - ball.y;
			ddX = (dogXStart + dog.width/2) - ball.x;
			
			chaseStart += .05;
			
			dog.scaleY = 1.0 / ((chaseStart / chaseS * chaseStart / chaseS - 11.0) / (chaseStart / chaseS * chaseStart/ chaseS + 9.0) + 1.95) / 2.0;
			dog.scaleX = dog.scaleY;
			
			
			dog.y = (dogYStart - ((((chaseStart * chaseStart) / chaseS) * ddY - 11.0) / (((chaseStart * chaseStart) / chaseS) + 9.0)));
			dog.x = (dogXStart - ((((chaseStart * chaseStart) / chaseS) * ddX - 11.0) / (((chaseStart * chaseStart) / chaseS) + 9.0)));
			
		}
		else 
		{
			chaseStart -= .05;
			
			dog.scaleY = 1.0 / ((chaseStart / chaseS * chaseStart / chaseS - 11.0) / (chaseStart / chaseS * chaseStart/ chaseS + 9.0) + 1.95) / 2.0;
			dog.scaleX = dog.scaleY;
			
			
			dog.y = (dogYStart - ((((chaseStart * chaseStart) / chaseS) * ddY - 11.0) / (((chaseStart * chaseStart) / chaseS) + 9.0)));
			dog.x = (dogXStart - ((((chaseStart * chaseStart) / chaseS) * ddX - 11.0) / (((chaseStart * chaseStart) / chaseS) + 9.0)));
			
			shadow.visible = false;
			
			
			ball.scaleY = 1.0 / ((chaseStart / chaseS * chaseStart / chaseS - 11.0) / (chaseStart / chaseS * chaseStart/ chaseS + 9.0) + 1.95) / 8.0;
			ball.scaleX = ball.scaleY;
			
			ball.y = dog.y + (dog.height/2);
			ball.x = dog.x + (dog.width/2);
			
			if(dog.y >= dogYStart)
			{
					[self reinitializeVars];
			}
				
		}

		
		
	}
	
	
	
	
}

- (void)onTouchEvent:(SPTouchEvent*)event
{
	
	
	
	SPTouch *touchDown = [[event touchesWithTarget:self andPhase:SPTouchPhaseBegan] anyObject];
	SPTouch *touchMoved = [[event touchesWithTarget:self andPhase:SPTouchPhaseMoved] anyObject];
	SPTouch *touchUp = [[event touchesWithTarget:self andPhase:SPTouchPhaseEnded] anyObject];
	
	if(touchDown)
	{
		if(!isThrown)
		{
		touchingBall = YES;
		}
		
	}else if(touchMoved)
	{
		if(!isThrown)
		{
		currentPos = [touchMoved locationInSpace:self.parent];
		
		ball.x = (currentPos.x - (ball.width/2));
		ball.y = (currentPos.y - (ball.height/2));
		
		shadow.x = ball.x;
		
		if(currentPos.y > furthestBack.y)
		{
			
			furthestBack.x = currentPos.x;
			furthestBack.y = currentPos.y;
			backTime = [touchMoved timestamp];
			
		}
		}
		
		
	}else if (touchUp && !isThrown)
	{
		
		touchingBall = NO;
		
		releaseTime = [touchUp timestamp];
		
		

		
		
		
		velocity = (sqrt(pow((releasePos.x - furthestBack.x), 2) + pow((releasePos.y - furthestBack.y), 2)))/(releaseTime - backTime);
		
		if(!(currentPos.y <= vanishingPoint.y))
		{
		if(velocity >= 10.0)
		{
				
		
		
		
		released = timer;
		yStart = currentPos.y - ball.width/2;
		xStart = currentPos.x;
		dY = yStart - vanishingPoint.y;
		dX = xStart - vanishingPoint.x;
			
		
		ballWidthStart = ball.width;
		
		
		furthestBack.x = stationaryX;
		furthestBack.y = stationaryY;
		isThrown = true;
			
		}
		}
		
		//NSLog(@"%f", velocity);
	}
	
		
}


@end
